/*==============================================================================
: LiFe
:     
:    
: ..
  : 28.02.2003
/*============================================================================*/
//#define NDEBUG
#include <math.h>

#define SM_INPUT "20_10.txt" /*    */

//#define _RND	//  
#define _DELTA			1e-3F
// ----------------    ------------------
#define _DELTAAIJ		1e-6F		//    -
#define _DELTACOL		1e-5F		//     
#define _DELTAROW		1e-3F		//     
#define _DELTACANONVIEW	9e-1F	//   T_0_0     

// ----------------   - ------------------
#define _DELTAX		1e-3F			//      x
#define _DELTAY		1e-3F			//      (. ) y
#define _DELTAZ		1e-3F			//    z
#define _DELTAH		1e-3F			//      < _EPSILON
#define _DELTACOR    1e-3F			//    
#define _RANDOMIZATION_X   2				// 0 - ; 1 -  ; 2 - 
#define _RANDOMIZATION_Y   2				// 0 - ; 1 -  ; 2 - 

#define _DELTAPOINT	_DELTA		//     

#define _EPSILONX	  	50e-1F			//    x

#define _EPSILONY	   50e-1F			//    y

#define _L				1				//   () , 

											//   ()    (L>=1 !)
#define _LCMAX			100000000			//       

#define _R				30			   //   
#define _PC				10000        //    
											// ( <1000  ).
#define _rRING			0.5			// %,   
#define _CC				10000000			// .      
											//  .
#define EXACT_ON		// ON/OFF - / c   
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
#define SM_MAX_DIM	400		/* -   -
										(   ) */
#define DA_MAX_DIM	10000	/* -    A  B 
										  */
#define SM_MAX_L		10			// - - ,    
#define _MAX_COUNT	1000		//     -

//      DELTA
#define _EQZERO(x,DELTA) (fabs(x)<DELTA)

// 
#define SIGN(x) (x<0?-1:1)

//    
#define ROUND(x) (fmod(fabs(x),1)<0.5?	(SIGN(x)>0?floor(x):ceil(x)):\
													(SIGN(x)>0?ceil(x):floor(x)))

/* --  : - -- */
/*
   -     ASCII,   :

        ,
      "%";

     ;

        ,  
   :
	
   
    
    

     n -   
(  ).
     m -   
(  ).
     -   
   :

   |_m+1	... 	_n	|
---+--------------------+----
_1|a_1_m+1... 	a_1_n|b_1
.  |.                  .|.
.  |.                  .|.
.  |.                  .|.
_m|a_m_m+1...	a_m_n|b_m
---+--------------------+----
   |p__m+1	...	p__n |-Q_0

*/

